/**
 * Forward declarations of classes to resolve compiler conflicts.
 *
 * Also declares a pointer type for each class, which is useful
 * when dealing with some declarations, such as constant
 * pointers and arrays of pointers.
 *
 * eg: Vertex, VertexPtr = Vertex*
 *     Face,   FacePtr   = Face*
 *     Mesh,   MeshPtr   = Mesh*
 **/
#ifndef __DECLARATIONS_H__
#define __DECLARATIONS_H__
#define DECLARE(C) \
  class C; \
  typedef C* C##Ptr

#include "Misc.h"

// mesh objects
DECLARE(Vertex);
DECLARE(Face);
DECLARE(Mesh);

#undef DECLARE
#endif

